diff -ru w3m-0.5+cvs-1.914/Makefile.in w3m/Makefile.in
--- w3m-0.5+cvs-1.914/Makefile.in	Sun Mar 28 00:20:33 2004
+++ w3m/Makefile.in	Sun Mar 28 02:58:49 2004
@@ -26,7 +26,6 @@
 top_srcdir = @top_srcdir@
 top_builddir = .
 VPATH = $(top_srcdir):.
-DESTDIR = 
 
 CGIBIN_DIR = $(libexecdir)/$(PACKAGE)/cgi-bin
 AUXBIN_DIR = $(libexecdir)/$(PACKAGE)
@@ -35,7 +34,7 @@
 ETC_DIR = $(sysconfdir)
 CONF_DIR = $(sysconfdir)/$(PACKAGE)
 
-CFLAGS = $(OPTS) @CFLAGS@ $(DEFS)
+CFLAGS = $(OPTS) @CFLAGS@ $(CPPFLAGS) $(DEFS)
 WCCFLAGS = @WCCFLAGS@
 CPPFLAGS = @CPPFLAGS@
 DEFS = @DEFS@ -I. -I$(top_srcdir) -DAUXBIN_DIR=\"$(AUXBIN_DIR)\" \
@@ -145,7 +144,14 @@
 	 sed -ne '/^DEFUN/{p;n;/^[ 	]/p;}' $(DEFUNS)) | $(CPP) - | \
 	 awk '$$1 ~ /^[_A-Za-z]/ { \
 	       for (i=2;i<=NF;i++) { print $$i, $$1} \
-	 }' > $@
+	 }' > $@.tmp
+	@if cmp -s $@.tmp $@; then \
+		echo "$@ unchanged"; \
+		rm $@.tmp; \
+	 else \
+	 	echo "$@ updated"; \
+		mv funcname.tab.tmp $@; \
+	 fi
 
 funcname.c: funcname.tab
 	sort funcname.tab | $(AWK) -f $(top_srcdir)/funcname0.awk > $@
diff -ru w3m-0.5+cvs-1.914/config.h.in w3m/config.h.in
--- w3m-0.5+cvs-1.914/config.h.in	Sat Nov  1 21:01:02 2003
+++ w3m/config.h.in	Sun Mar 28 02:58:49 2004
@@ -107,6 +107,8 @@
 #undef HAVE_SGTTY_H
 #undef HAVE_DIRENT_H
 #undef HAVE_LOCALE_H
+#undef HAVE_STDINT_H
+#undef HAVE_INTTYPES_H
 #define SIZEOF_LONG_LONG 8
 #if SIZEOF_LONG_LONG > 0
 typedef long long clen_t;
diff -ru w3m-0.5+cvs-1.914/configure.in w3m/configure.in
--- w3m-0.5+cvs-1.914/configure.in	Sun Mar 28 00:20:35 2004
+++ w3m/configure.in	Sun Mar 28 02:58:49 2004
@@ -28,9 +28,8 @@
 AC_PATH_PROGS(PERL, perl, /usr/local/bin/perl)
 AC_PATH_PROGS(NKF, nkf, /usr/local/bin/nkf)
 AC_PATH_PROGS(MAN, man, /usr/bin/man)
-AC_CANONICAL_SYSTEM
+AC_CANONICAL_HOST
 
-AC_CYGWIN
 AC_EXEEXT
 AC_SUBST(EXEEXT)
 
@@ -110,9 +109,11 @@
 AC_DEFINE(AUXBIN_TARGETS, "$AUXBIN_TARGETS")
 
 AC_SUBST(USE_BINMODE_STREAM)
-if test x$CYGWIN = xyes; then
- AC_DEFINE(USE_BINMODE_STREAM)
-fi
+case "$host_os" in
+    *cygwin*)
+    AC_DEFINE(USE_BINMODE_STREAM)
+    ;;
+esac
 
 AC_HEADER_DIRENT
 AC_HEADER_STDC
@@ -121,9 +122,11 @@
 AC_CHECK_HEADER(termios.h, [AC_DEFINE(HAVE_TERMIOS_H)],
 	 [AC_CHECK_HEADER(termio.h, [AC_DEFINE(HAVE_TERMIO_H)],
 	  [AC_CHECK_HEADER(sgtty.h, [AC_DEFINE(HAVE_SGTTY_H)])])])
-AC_CHECK_HEADER([float.h])
-AC_CHECK_HEADER([sys/select.h])
+AC_CHECK_HEADER([float.h], [AC_DEFINE(HAVE_FLOAT_H)])
+AC_CHECK_HEADER([sys/select.h], [AC_DEFINE(HAVE_SYS_SELECT_H)])
 AC_CHECK_HEADER([locale.h], [AC_DEFINE(HAVE_LOCALE_H)])
+AC_CHECK_HEADER([stdint.h], [AC_DEFINE(HAVE_STDINT_H)])
+AC_CHECK_HEADER([inttypes.h], [AC_DEFINE(HAVE_INTTYPES_H)])
 
 dnl Checks for typedefs, structures, and compiler characteristics.
 dnl AC_C_CONST
diff -ru w3m-0.5+cvs-1.914/etc.c w3m/etc.c
--- w3m-0.5+cvs-1.914/etc.c	Sat Nov  1 21:01:02 2003
+++ w3m/etc.c	Sun Mar 28 02:58:49 2004
@@ -957,7 +957,7 @@
     struct auth_pass *ent;
     for (ent = passwords; ent != NULL; ent = ent->next) {
 	if (ent->is_proxy == is_proxy
-	    && (!ent->host || !Strcmp_charp(ent->host, host))
+	    && (!ent->host || !Strcasecmp_charp(ent->host, host))
 	    && (!ent->port || ent->port == port)
 	    && (!ent->file || !file || dir_under(ent->file->ptr, file))
 	    && (!ent->realm || !realm || !Strcmp_charp(ent->realm, realm))
diff -ru w3m-0.5+cvs-1.914/libwc/wc_types.h w3m/libwc/wc_types.h
--- w3m-0.5+cvs-1.914/libwc/wc_types.h	Tue Sep 23 06:02:23 2003
+++ w3m/libwc/wc_types.h	Sun Mar 28 02:58:49 2004
@@ -3,11 +3,23 @@
 #define _WC_TYPES_H
 
 #include <Str.h>
+#include <config.h>
+#if defined(HAVE_STDINT_H)
+# include <stdint.h>
+#elif defined(HAVE_INTTYPES_H)
+# include <inttypes.h>
+#endif
 
 typedef unsigned char  wc_uchar;
+#if defined(HAVE_STDINT_H) || defined(HAVE_INTTYPES_H)
+typedef uint8_t  wc_uint8;
+typedef uint16_t wc_uint16;
+typedef uint32_t wc_uint32;
+#else
 typedef unsigned char  wc_uint8;
 typedef unsigned short wc_uint16;
 typedef unsigned long  wc_uint32;
+#endif
 
 typedef wc_uint32 wc_ccs;
 typedef wc_uint32 wc_ces;
diff -ru w3m-0.5+cvs-1.914/main.c w3m/main.c
--- w3m-0.5+cvs-1.914/main.c	Sun Mar 28 00:20:35 2004
+++ w3m/main.c	Sun Mar 28 02:58:49 2004
@@ -383,6 +383,7 @@
     wc_ces CodePage;
 #endif
 #endif
+    GC_init();
     setlocale(LC_ALL, "");
     bindtextdomain(PACKAGE, LOCALEDIR);
     textdomain(PACKAGE);